unit Unit1;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs, FMX.StdCtrls,
  FMX.WebBrowser, Soap.SOAPHTTPTrans, Unit2;

type
  TForm1 = class(TForm)
    WebBrowser1: TWebBrowser;
    ToolBar1: TToolBar;
    ToolBar2: TToolBar;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    HTTPReqResp1: THTTPReqResp;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    FURL: String;
    FServerULR: String;
    FStrLit: TStringList;
    FnPage: Integer;
    procedure FormListClose(Sender: TObject; var Action: TCloseAction);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

procedure TForm1.Button1Click(Sender: TObject);
var
  Mem: TMemoryStream;
  i: Integer;
begin
  Mem := TMemoryStream.Create;
  try
    HTTPReqResp1.URL := FServerULR + '/getvariable=SERVER_REPORTS_LIST';
    HTTPReqResp1.Get(Mem);
    mem.Position := 0;
    FStrLit.LoadFromStream(Mem);
    Form2.ListBox1.Clear;
    for i := 0 to FStrLit.Count - 1 do
      if (i + 1) mod 3 = 0 then
        Form2.ListBox1.Items.Add(FStrLit[i - 2]);
    Form2.OnClose := FormListClose;
    Form2.Show;
  finally
    Mem.Free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if WebBrowser1.URL = '' then Exit;
  WebBrowser1.Navigate;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  if FnPage < 1 then Exit;
  Dec(FnPage);

  WebBrowser1.URL := FURL + '&pagerange=' + IntToStr(FnPage);
  WebBrowser1.Navigate;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  Inc(FnPage);
  WebBrowser1.URL := FURL + '&pagerange=' + IntToStr(FnPage);
  WebBrowser1.Navigate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FServerULR := 'http://192.168.1.10:8097';
  FURL := '';
  WebBrowser1.EnableCaching := False;
  FStrLit := TStringList.Create;
  FnPage := 0;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FStrLit.Free;
end;

procedure TForm1.FormListClose(Sender: TObject; var Action: TCloseAction);
begin
  if FStrLit.Count < Form2.Selected * 2 + 1 then Exit;
  FURL := FServerULR + '/result?report=' + FStrLit[Form2.Selected * 3 + 1] + '&pagenav=0';
  WebBrowser1.URL := FURL;
  FnPage := 1;
  Button2Click(Sender);
end;

end.
