unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Data.DB, Data.Win.ADODB, frxExportCSV,
  frxExportXLS, frxExportXML, frxExportODF, frxExportHTML, frxClass,
  frxExportPDF, frxADOComponents, frxChart, frxDesgn, frxServer, frxServerConfig,
  Vcl.StdCtrls, Vcl.ExtCtrls, frxServerStat, frxVariables;

type
  TForm1 = class(TForm)
    frxReportServer1: TfrxReportServer;
    frxReport1: TfrxReport;
    frxDesigner1: TfrxDesigner;
    frxChartObject1: TfrxChartObject;
    frxADOComponents1: TfrxADOComponents;
    frxPDFExport1: TfrxPDFExport;
    frxHTMLExport1: TfrxHTMLExport;
    frxODTExport1: TfrxODTExport;
    frxODSExport1: TfrxODSExport;
    frxXMLExport1: TfrxXMLExport;
    frxXLSExport1: TfrxXLSExport;
    frxCSVExport1: TfrxCSVExport;
    ServerDatabase: TADOConnection;
    StartServB: TButton;
    DesignReportB: TButton;
    StopServB: TButton;
    ServerStatLB: TLabel;
    TotalSLB: TLabel;
    TotalSE: TEdit;
    TotalRepLB: TLabel;
    TotalRepE: TEdit;
    CurSLB: TLabel;
    CurSE: TEdit;
    CurRepLB: TLabel;
    CurRepE: TEdit;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure StartServBClick(Sender: TObject);
    procedure StopServBClick(Sender: TObject);
    procedure DesignReportBClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const StrStatus = 'Server Status :';
procedure TForm1.DesignReportBClick(Sender: TObject);
begin
  frxDesigner1.OpenDir := ExtractFilePath(Application.ExeName) + Copy(ServerConfig.GetValue('server.reports.Path'), 3, length(ServerConfig.GetValue('server.reports.Path')));
  frxReport1.DesignReport();
  frxReportServer1.Close;
  frxReportServer1.Open;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ServerDatabase.ConnectionString := ServerConfig.GetValue('server.database.ConnectionString');
  try
    ServerDatabase.Open();
    ServerStatLB.Caption := StrStatus + 'Database connected!';
    StopServB.Enabled := False;
  except
    ServerStatLB.Caption := StrStatus + 'cannot connect to Database!';
  end;
end;

procedure TForm1.StartServBClick(Sender: TObject);
begin
  if ServerDatabase.Connected then
  begin
    frxReportServer1.Open;
    if frxReportServer1.Active then
    begin
      StartServB.Enabled := False;
      StopServB.Enabled := True;
      ServerStatLB.Caption := StrStatus + 'server is running!';
    end;
  end;
end;

procedure TForm1.StopServBClick(Sender: TObject);
begin
  frxReportServer1.Close;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  TotalSE.Text := IntToStr(ServerStatistic.TotalSessionsCount);
  TotalRepE.Text := IntToStr(ServerStatistic.TotalReportsCount);
  CurSE.Text := IntToStr(ServerStatistic.CurrentSessionsCount);
  CurRepE.Text := IntToStr(ServerStatistic.CurrentReportsCount);
  if frxReportServer1.Active then
  begin
    StartServB.Enabled := False;
    StopServB.Enabled := True;
    ServerStatLB.Caption := StrStatus + 'server is running!';
  end
  else
  begin
    StartServB.Enabled := True;
    StopServB.Enabled := False;
    ServerStatLB.Caption := StrStatus + 'server stopped!';
  end;
end;

end.
